--do not announce low mana/power when changing specs.  still do hud etc.

--define global vars and defaults (saved between sessions)
local function SetDefaults()
	KLM_Settings = {
		["DoHealth"] = true,
		["DoPower"] = true,
		["SpamLimiter"] = 120,
		["AudibleAlertsOn"] = true,
		["HUDOn"] = true,
		["AnnouncePartyOn"] = false,
		["AnnounceRaidOn"] = false
	}
end
SetDefaults()

local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("KLM: " .. tostring(msg))
end

--define static HEALTH vars and initialize them
local HealthMax = UnitHealthMax("player")
local HealthLevel = UnitHealth("player")
local HealthPercent = floor(100 * HealthLevel / HealthMax)
local LastHealthMax = HealthMax
local LastHealthLevel = HealthLevel
local LastHealthPercent = HealthPercent
local HealthAlarmLevel = 4  -- 1=LowLow, 2=Low, 3=Normal, 4=Full
--health chatbox SPAMMING control
local LastHealthAnnounce = "" --what was the last chat msg for health?
local HealthSpamTimer = 0

--define static POWER vars and initialize them
local PowerType, PowerTypeS = UnitPowerType("player")
local PowerMax = UnitPowerMax("player")
local PowerLevel = UnitPower("player")
local PowerPercent = floor(100 * PowerLevel / PowerMax)
local PowerTypeEnabled = false --do we want to monitor the current power type or disable?
local LastPowerType = PowerType
local LastPowerTypeS = PowerTypeS
local LastPowerMax = PowerMax
local LastPowerLevel = PowerLevel
local LastPowerPercent = PowerPercent
local LastPowerTypeEnabled = PowerTypeEnabled
local PowerAlarmLevel = 4  -- 0=Empty, 1=LowLow, 2=Low, 3=Normal, 4=Full
--power chatbox SPAMMING control
local LastPowerAnnounce = "" --what was the last chat msg for power?
local PowerSpamTimer = 0
-- miscellanious
local SpecChanged = false

local function KUpdate()
	local MTHealth={} --"Message Table" for health to build all the msgs to display at end of loop
	local MTPower={} --"Message Table" for power to build all the msgs to display at end of loop
	local DoAlarmOnce=false
	local Role = UnitGroupRolesAssigned("player")
	local Index

	if KLM_Settings.DoHealth then
		--gather new health values
		HealthMax = UnitHealthMax("player")
		HealthLevel = UnitHealth("player")
		HealthPercent = floor(100 * HealthLevel / HealthMax)+1
		--gather new power values
		PowerType, PowerTypeS = UnitPowerType("player")
		PowerMax = UnitPowerMax("player")
		PowerLevel = UnitPower("player")
		PowerPercent = floor(100 * PowerLevel / PowerMax)+1

		--notify on health level changes
		if HealthMax ~= LastHealthMax then
			table.insert(MTHealth,{Msg="Max health changed.",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
		end
		--if there is a health level change then build messages
		if HealthPercent ~= LastHealthPercent then
			--health
			if HealthPercent == 0 then
				table.insert(MTHealth,{Msg="Argh!",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
				if HealthAlarmLevel > 0 then --only do once when changing to this alarm level
					MTHealth[#MTHealth].HUD=true
					if (LastHealthAnnounce ~= MTHealth[#MTHealth].Msg) and (time() - HealthSpamTimer > KLM_Settings.SpamLimiter) then
						MTHealth[#MTHealth].Announce=true; HealthSpamTimer = time() --enable chatbox announcement and reset spam timer
						LastHealthAnnounce=MTHealth[#MTHealth].Msg
					end
				end
				HealthAlarmLevel = 0
			elseif HealthPercent < 10 then
				table.insert(MTHealth,{Msg="Almost dead! ("..HealthPercent.."%)",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
				MTHealth[#MTHealth].HUD=true --repeatedly show on HUD
				if HealthAlarmLevel > 1 then --only do once when changing to this alarm level
					MTHealth[#MTHealth].Alarm=true
				end
				HealthAlarmLevel = 1
			elseif HealthPercent < 35 then
				table.insert(MTHealth,{Msg="Health is low. ("..HealthPercent.."%)",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
				if HealthAlarmLevel > 2 then --only do once when changing to this alarm level
					MTHealth[#MTHealth].HUD=true
					MTHealth[#MTHealth].Alarm=true
				end
				HealthAlarmLevel = 2
			elseif HealthPercent < 95 then 
				if HealthAlarmLevel > 3 then --only do once when changing to this alarm level
					--nothing to do at this time
				end
				HealthAlarmLevel = 3
			elseif HealthPercent == 100 then 
				if HealthAlarmLevel < 4 then --only do once when changing to this alarm level
					table.insert(MTHealth,{Msg="Full Health restored.",HUD=true,Alarm=false,TTL=1,Announce=false,Print=false})
				end
				HealthAlarmLevel = 4
			end
		end
	end

	if KLM_Settings.DoPower then
		--notify on power type and power maximum changes
		--do we want to monitor the current powertype?
		if PowerType == SPELL_POWER_MANA then PowerTypeEnabled = true --0 to variable
		elseif PowerType == SPELL_POWER_RAGE then PowerTypeEnabled = false --0 to 100
		elseif PowerType == SPELL_POWER_FOCUS then PowerTypeEnabled = false --100 to 0
		elseif PowerType == SPELL_POWER_ENERGY then PowerTypeEnabled = false --??
		elseif PowerType == SPELL_POWER_HAPPINESS then PowerTypeEnabled = false --??
		elseif PowerType == SPELL_POWER_RUNES then PowerTypeEnabled = false --??
		elseif PowerType == SPELL_POWER_RUNIC_POWER then PowerTypeEnabled = false --??
		elseif PowerType == SPELL_POWER_SOUL_SHARDS then PowerTypeEnabled = false --??
		elseif PowerType == SPELL_POWER_ECLIPSE then PowerTypeEnabled = false --??
		elseif PowerType == SPELL_POWER_HOLY_POWER then PowerTypeEnabled = false --??
		end
		if PowerType ~= LastPowerType then
			table.insert(MTPower,{Msg=PowerTypeS.." has replaced "..LastPowerTypeS..".",HUD=false,Alarm=false,TTL=6,Announce=false,Print=true})
		elseif (PowerMax ~= LastPowerMax) and PowerTypeEnabled then
			table.insert(MTPower,{Msg="Max "..PowerTypeS.." changed.",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
		end
		if PowerTypeEnabled ~= LastPowerTypeEnabled then
			if PowerTypeEnabled then
				table.insert(MTPower,{Msg="Enabling power monitoring for "..PowerTypeS.." power type.",HUD=false,Alarm=false,TTL=6,Announce=false,Print=true})
			else
				table.insert(MTPower,{Msg="Disabling power monitoring for "..PowerTypeS.." power type.",HUD=false,Alarm=false,TTL=6,Announce=false,Print=true})
			end
		end
		--if there is a power level change then build messages
		if (PowerPercent ~= LastPowerPercent) and PowerTypeEnabled and not UnitIsDeadOrGhost("player") then
			--power
			if PowerPercent == 0 then
				table.insert(MTPower,{Msg="No "..PowerTypeS.." remaining.",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
				MTPower[#MTPower].HUD=true --repeatedly show on HUD
				if PowerAlarmLevel > 0 then --only do once when changing to this alarm level
					MTPower[#MTPower].Alarm=true
					if (LastPowerAnnounce ~= MTPower[#MTPower].Msg) and (time() - PowerSpamTimer > KLM_Settings.SpamLimiter) then
						MTPower[#MTPower].Announce=true; PowerSpamTimer = time() --enable chatbox announcement and reset spam timer
						LastPowerAnnounce=MTPower[#MTPower].Msg
					end
				end
				PowerAlarmLevel = 0
			elseif PowerPercent < 10 then
				table.insert(MTPower,{Msg="Almost out of "..PowerTypeS.." ("..PowerPercent.."%)",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
				MTPower[#MTPower].HUD=true --repeatedly show on HUD
				if PowerAlarmLevel > 1 then --only do once when changing to this alarm level
					MTPower[#MTPower].Alarm=true
					if (LastPowerAnnounce ~= MTPower[#MTPower].Msg) and (time() - PowerSpamTimer > KLM_Settings.SpamLimiter) then
						MTPower[#MTPower].Announce=true; PowerSpamTimer = time() --enable chatbox announcement and reset spam timer
						LastPowerAnnounce=MTPower[#MTPower].Msg
					end
				end
				PowerAlarmLevel = 1
			elseif PowerPercent < 30 then
				table.insert(MTPower,{Msg=PowerTypeS.." is low. ("..PowerPercent.."%)",HUD=false,Alarm=false,TTL=1,Announce=false,Print=false})
				if PowerAlarmLevel > 2 then --only do once when changing to this alarm level
					MTPower[#MTPower].HUD=true
					MTPower[#MTPower].Alarm=true
				end
				PowerAlarmLevel = 2
			elseif PowerPercent < 95 then 
				if PowerAlarmLevel > 3 then --only do once when changing to this alarm level
					--nothing to do at this time
				end
				PowerAlarmLevel = 3
			elseif PowerPercent == 100 then 
				if PowerAlarmLevel < 4 then --only do once when changing to this alarm level
					table.insert(MTPower,{Msg="Full "..PowerTypeS.." restored.",HUD=true,Alarm=false,TTL=1,Announce=false,Print=false})
				end
				PowerAlarmLevel = 4 --reset audible alarm
			end
			if PowerPercent > 10 then
				SpecChanged = false --make sure we are announcing to chat now
			end
		end
	end
	
	--display any health alerts
	for Index=1, #MTHealth, 1 do 
		--display any health alerts
		KLifeMonFrame:SetTimeVisible(MTHealth[Index].TTL)  --how long to show in HUD
		if MTHealth[Index].HUD and KLM_Settings.HUDOn then 
			KLifeMonFrame:AddMessage(MTHealth[Index].Msg, 0, 1, 0, nil, 3) --show in HUD
		end
		if MTHealth[Index].Announce and Role == "HEALER" then  --announce to chatbox?
			if UnitInRaid("player") and KLM_Settings.AnnounceRaidOn then
				SendChatMessage(Role..": "..MTHealth[Index].Msg, "RAID")
			elseif UnitInParty("player") and GetNumPartyMembers() >= 1 and KLM_Settings.AnnouncePartyOn then
				SendChatMessage(Role..": "..MTHealth[Index].Msg, "PARTY")
			else
				print(Role..": "..MTHealth[Index].Msg)
			end
		end
		if MTHealth[Index].Alarm then DoAlarmOnce=true; end
	end
	
	--display any power alerts
	for Index=1, #MTPower, 1 do 
		--display any power alerts
		KLifeMonFrame:SetTimeVisible(MTPower[Index].TTL)  --how long to show in HUD
		if MTPower[Index].HUD and KLM_Settings.HUDOn then 
			KLifeMonFrame:AddMessage(MTPower[Index].Msg, PowerBarColor[PowerTypeS].r, PowerBarColor[PowerTypeS].g, PowerBarColor[PowerTypeS].b, nil, 3) --show in HUD
		end
		if MTPower[Index].Announce and Role == "HEALER" then  --announce to chatbox?
			if UnitInRaid("player") and KLM_Settings.AnnounceRaidOn and SpecChanged == false then
				SendChatMessage(Role..": "..MTPower[Index].Msg, "RAID")
				--print("RAID="..Role..": "..MTPower[Index].Msg)
			elseif UnitInParty("player") and GetNumPartyMembers() > 1 and KLM_Settings.AnnouncePartyOn and SpecChanged == false then
				SendChatMessage(Role..": "..MTPower[Index].Msg, "PARTY")
				--print("PARTY="..Role..": "..MTPower[Index].Msg)
			else
				print(Role..": "..MTPower[Index].Msg)
			end
		end
		if MTPower[Index].Alarm then DoAlarmOnce=true; end
	end
	
	--play alarm but only once for this loop of messages
	if DoAlarmOnce and KLM_Settings.AudibleAlertsOn then
		PlaySoundFile("Interface\\addons\\KLifeMon\\HyprBlip.mp3")
	end
	
	--save old health values
	LastHealthMax = HealthMax
	LastHealthLevel = HealthLevel
	LastHealthPercent = HealthPercent
	--save old power values
	LastPowerType = PowerType
	LastPowerTypeS = PowerTypeS
	LastPowerMax = PowerMax
	LastPowerLevel = PowerLevel
	LastPowerPercent = PowerPercent
	LastPowerTypeEnabled = PowerTypeEnabled
end

--[[ 
function Aspect_CreateFlasher(color)
	local frameImage = "None";
	if(color == "Blue") then
		frameImage = "Interface\\FullScreenTextures\\OutofControl";
	elseif(color == "Red") then
		frameImage = "Interface\\FullScreenTextures\\LowHealth";
	else
		frameImage = nil;
	end

	local frameName = "Aspect"..color.."WarningFrame";
	if not ((Flasher[color]) and (frameImage)) then
		local flasher = CreateFrame("Frame", frameName)
		flasher:SetToplevel(true)
		flasher:SetFrameStrata("FULLSCREEN_DIALOG")
		flasher:SetAllPoints(UIParent)
		flasher:EnableMouse(false)
		flasher.texture = flasher:CreateTexture(nil, "BACKGROUND")
		flasher.texture:SetTexture(frameImage)
		flasher.texture:SetAllPoints(UIParent)
		flasher.texture:SetBlendMode("ADD")
		flasher:Hide()
		flasher:SetScript("OnShow", function(self)
			self.elapsed = 0
			self:SetAlpha(0)
		end)
		flasher:SetScript("OnUpdate", function(self, elapsed)
			elapsed = self.elapsed + elapsed
			if Aspect_FlasherSound(sound) then
				self:Hide()
				self:SetAlpha(0)
				flashcount = 0;
				Printcount = true;
				Control.PrintAspect = "Dragonhawk";
				return
			end
			local alpha = elapsed % 0.4
			if elapsed > 0.2 then
				alpha = 0.4 - alpha
			end
			self:SetAlpha(alpha * 5)
			self.elapsed = elapsed
		end)
		Flasher[color] = flasher;
	end
end
 ]]

function KLifeMon_OnLoad(self)

    KLifeMonFrame:RegisterEvent("UNIT_POWER")
    KLifeMonFrame:RegisterEvent("UNIT_MAXPOWER")
    KLifeMonFrame:RegisterEvent("UNIT_HEALTH")
    KLifeMonFrame:RegisterEvent("UNIT_MAXHEALTH")
    KLifeMonFrame:RegisterEvent("UNIT_DISPLAYPOWER")
    KLifeMonFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
    KLifeMonFrame:RegisterEvent("RAID_ROSTER_UPDATE")
    KLifeMonFrame:RegisterEvent("ROLE_CHANGED_INFORM")
    KLifeMonFrame:RegisterEvent("ADDON_LOADED")
	KLifeMonFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	KLifeMonFrame:SetWidth(450)
	KLifeMonFrame:SetHeight(200)
	KLifeMonFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)	
	KLifeMonFrame:SetFont("Interface\\addons\\KLifeMon\\swissek.ttf",30,"THICKOUTLINE")
	KLifeMonFrame:SetShadowColor(0.00,0.00,0.00,0.75)
	KLifeMonFrame:SetShadowOffset(3.00,-3.00)
	KLifeMonFrame:SetJustifyH("CENTER")		
	KLifeMonFrame:SetMaxLines(2)
	KLifeMonFrame:SetTimeVisible(1)
	KLifeMonFrame:SetFadeDuration(1)

	print("Loaded.  Use /KLM for the options.")
end

function KLifeMon_OnEvent(frame,event,...)
	if event == "ADDON_LOADED" and select(1,...) == "KLifeMon" then
		--vars loaded from saved settings
		LoadOptionSettings() --load global vars to option controls
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		SpecChanged = true --make sure we are not announcing to chat
	else
		KUpdate()
	end
end

function KLifeMonOptions_OnLoad(panel)
	local WoWver = select(4, GetBuildInfo())
	-- Set the name for the Category for the Panel
	panel.name = "Life Monitor " .. GetAddOnMetadata("KLifeMon", "Version");

	--define the functions that will run when the user clicks on the associated buttons
	panel.okay = function(self) KLifeMonOptions_Close(); end;
	panel.cancel = function(self)  KLifeMonOptions_Cancel(); end;
	panel.default = function(self)  KLifeMonOptions_Defaults(); end;
	--panel.parent = ""
	--panel.refresh = function(self)  KLifeMonOptions_Refresh();  end;

	-- Add the panel to the Interface Options
	InterfaceOptions_AddCategory(panel)

	--define the direct to options command
	SlashCmdList["KLifeMonOptions"] = KLifeMonOptions_Command
	SLASH_KLifeMonOptions1 = "/klm"
end

function KLifeMonOptions_Command(Msg,Editbox)
	InterfaceOptionsFrame_OpenToCategory(KLifeMonOptionsFrame)
end

function KLifeMonOptions_Close()
	--save option control settings to global vars
	KLM_Settings.DoHealth=KLifeMonOptionsFrame_CBHealth:GetChecked()
	KLM_Settings.DoPower=KLifeMonOptionsFrame_CBPower:GetChecked()
	KLM_Settings.SpamLimiter=KLifeMonOptionsFrame_SpamLimiterSlider:GetValue()
	KLM_Settings.AudibleAlertsOn=KLifeMonOptionsFrame_CBAudible:GetChecked()
	KLM_Settings.HUDOn=KLifeMonOptionsFrame_CBHUD:GetChecked()
	KLM_Settings.AnnouncePartyOn=KLifeMonOptionsFrame_CBParty:GetChecked()
	KLM_Settings.AnnounceRaidOn=KLifeMonOptionsFrame_CBRaid:GetChecked()
end

function KLifeMonOptions_Cancel()
	LoadOptionSettings()
end

function KLifeMonOptions_Defaults()
	SetDefaults()
	LoadOptionSettings()
end

function LoadOptionSettings()
	--set option controls from global vars
	KLifeMonOptionsFrame_CBHealth:SetChecked(KLM_Settings.DoHealth)
	KLifeMonOptionsFrame_CBPower:SetChecked(KLM_Settings.DoPower)
	KLifeMonOptionsFrame_SpamLimiterSlider:SetMinMaxValues(1,300)
	KLifeMonOptionsFrame_SpamLimiterSlider:SetValueStep(1)
	KLifeMonOptionsFrame_SpamLimiterSliderLow:SetText("1")
	KLifeMonOptionsFrame_SpamLimiterSliderHigh:SetText("300 (5 Mins)")
	KLifeMonOptionsFrame_SpamLimiterSlider:SetValue(KLM_Settings.SpamLimiter)
	KLifeMonOptionsFrame_CBAudible:SetChecked(KLM_Settings.AudibleAlertsOn)
	KLifeMonOptionsFrame_CBHUD:SetChecked(KLM_Settings.HUDOn)
	KLifeMonOptionsFrame_CBParty:SetChecked(KLM_Settings.AnnouncePartyOn)
	KLifeMonOptionsFrame_CBRaid:SetChecked(KLM_Settings.AnnounceRaidOn)
end

function KLifeMonOptionsFrame_SpamLimiterSlider_OnValueChanged(self, value)
	KLifeMonOptionsFrame_SpamLimiterSlider_Seconds:SetText(tostring(value).." second(s)")
end